#include "ISommePtr.h"
#include "../../Commun/Commun/Somme_h.h"
#include "../../Commun/Commun/UUID_Fabriques.h"
#include <memory>
using namespace std;

ISommePtr::ISommePtr() {
   IUnknown *pUnk{};
   auto hr = CoCreateInstance(
      CLSID_FabriqueSommateur, nullptr, CLSCTX_INPROC_SERVER, IID_IUnknown, reinterpret_cast<void **>(&pUnk)
   );
   if (FAILED(hr)) throw erreur_creation{};
   ISomme *pSomme{};
   hr = pUnk->QueryInterface(IID_ISomme, reinterpret_cast<void**>(&pSomme));
   pUnk->Release();
   if (FAILED(hr)) throw erreur_creation{};
   p.reset(pSomme);
}

ISommePtr::~ISommePtr() = default;

int ISommePtr::somme(int x, int y) const {
   int resultat;
   if (auto hr = p->somme(x, y, &resultat); FAILED(hr))
      throw erreur_calcul{};
   return resultat;
}
