// Fichier ConversionChaines.cpp

#include "ConversionChaines.h"
#include <string>
#include <algorithm>
#include <locale>
using namespace std;

template <class CDest, class CSrc>
basic_string<CDest> rebuild(const basic_string<CSrc> &s) {
   return{ begin(s), end(s) };
}

wstring StringToWString(const string &s) {
   return rebuild<wstring::value_type>(s);
}

string WStringToString(const wstring &s) {
   return rebuild<string::value_type>(s);
}

template <class C>
   basic_string<C> majuscules_(const basic_string<C> &s) {
      basic_string<C> resultat(s.size(), C{});
      transform(s.begin(), s.end(), resultat.begin(), [loc = locale{ "" }](C c) {
         return toupper(c, loc);
      });
      return resultat;
   }

// Retourne la version majuscule du texte en paramtre
string majuscules(const string &s) {
   return majuscules_(s);
}
