#ifndef ICLASSFACTORYIMPL_H
#define ICLASSFACTORYIMPL_H

#include "GestionnaireVerrou.h"
#include "IntrusiveShareable.h"
#include <Unknwn.h>

template <class T>
   struct IClassFactoryImpl : private IntrusiveShareable, IClassFactory {
      unsigned long __stdcall AddRef() override {
         return add_ref();
      }
      unsigned long __stdcall Release() override {
         return release();
      }
      HRESULT __stdcall QueryInterface(REFIID riid, void **ppv) {
         if (riid == IID_IUnknown) {
            *ppv = static_cast<IUnknown*>(this);
         } else if (riid == IID_IClassFactory) {
            *ppv = static_cast<IClassFactory*>(this);
         } else {
            *ppv = nullptr;
            return E_NOINTERFACE;
         }
         AddRef();
         return S_OK;
      }
      HRESULT __stdcall LockServer(BOOL fLock) override {
         if (fLock)
            GestionnaireVerrou::get().incrementer();
         else
            GestionnaireVerrou::get().decrementer();
         return S_OK;
      }
      HRESULT __stdcall CreateInstance(IUnknown *pUnkOuter, REFIID riid, void **ppv) {
         if (pUnkOuter)
            return CLASS_E_NOAGGREGATION;
         try {
            auto p = new T;
            auto hr = p->QueryInterface(riid, ppv);
            p->Release();
            return hr;
         } catch (...) {
            return E_OUTOFMEMORY;
         }
      }
   };

#endif
