#ifndef INTRUSIVESHAREABLE_H
#define INTRUSIVESHAREABLE_H

#include <atomic>

class IntrusiveShareable {
   std::atomic<unsigned long> cptref{ 1 };
public:
   unsigned long add_ref() {
      return ++cptref;
   }
   unsigned long release() {
      if (auto n = cptref--; n != 1)
         return n - 1;
      delete this;
      return {};
   }
   virtual ~IntrusiveShareable() = default;
};

#endif
