#include "../../Commun/Commun/Somme_h.h"
#include "Sommateur.h"
#include "IClassFactoryImpl.h"
#include "GestionnaireVerrou.h"
#include <atomic>
using namespace std;

using FabriqueSommateur = IClassFactoryImpl<Sommateur>;

#include "../../Commun/Commun/UUID_Fabriques.h"
#include "Registry.h" // RegisterServer(), UnregisterServer()
#include <string>

// Utilitaires de support au contexte
const wstring SRV_NOMFICH = L"ServeurSommateur.dll"
, SRV_DESCR = L"Composant interne de dmonstration (refactoris)"
, SRV_NOM = L"Composant.Sommateur.InProc"
, SRV_VERSION = L"Composant.Sommateur.InProc.2"
;

HRESULT __stdcall DllRegisterServer() {
   return RegisterServer(
      SRV_NOMFICH, CLSID_FabriqueSommateur, SRV_DESCR, SRV_NOM, SRV_VERSION
   );
}
HRESULT __stdcall DllUnregisterServer() {
   return UnregisterServer(CLSID_FabriqueSommateur, SRV_NOM, SRV_VERSION);
}

HRESULT __stdcall DllGetClassObject(REFCLSID clsid, REFIID riid, void **ppv) {
   if (clsid != CLSID_FabriqueSommateur)
      return CLASS_E_CLASSNOTAVAILABLE;
   try {
      auto p = new FabriqueSommateur;
      // riid est probablement IID_IClassFactory
      auto hr = p->QueryInterface(riid, ppv);
      p->Release();
      return hr;
   } catch (...) {
      return E_OUTOFMEMORY;
   }
}

HRESULT __stdcall DllCanUnloadNow() {
   return GestionnaireVerrou::get().est_vide()? S_OK : S_FALSE;
}

